; ====================================================;
;                                                     ;
;     shell32.inc for EC v2 Fasm classic projects     ;
;                   (version 1.0.1)                   ;
;                                                     ;
;            Copyright  Ramon Sala - 2018            ;
;                                                     ;
; ====================================================;

if ~defined SHELL32_INC
define SHELL32_INC 1

if defined APP_WIN64
    import shell32,\
    AppCompat_RunDLLW,'AppCompat_RunDLLW',\
    AssocCreateForClasses,'AssocCreateForClasses',\
    AssocGetDetailsOfPropKey,'AssocGetDetailsOfPropKey',\
    CallCPLEntry16,'CallCPLEntry16',\
    CDefFolderMenu_Create,'CDefFolderMenu_Create',\
    CDefFolderMenu_Create2,'CDefFolderMenu_Create2',\
    CheckEscapesA,'CheckEscapesA',\
    CheckEscapesW,'CheckEscapesW',\
    CIDLData_CreateFromIDArray,'CIDLData_CreateFromIDArray',\
    CommandLineToArgvW,'CommandLineToArgvW',\
    Control_FillCache_RunDLLA,'Control_FillCache_RunDLLA',\
    Control_FillCache_RunDLLW,'Control_FillCache_RunDLLW',\
    Control_RunDLLA,'Control_RunDLLA',\
    Control_RunDLLAsUserW,'Control_RunDLLAsUserW',\
    Control_RunDLLW,'Control_RunDLLW',\
    DAD_AutoScroll,'DAD_AutoScroll',\
    DAD_DragEnterEx,'DAD_DragEnterEx',\
    DAD_DragEnterEx2,'DAD_DragEnterEx2',\
    DAD_DragLeave,'DAD_DragLeave',\
    DAD_DragMove,'DAD_DragMove',\
    DAD_SetDragImage,'DAD_SetDragImage',\
    DAD_ShowDragImage,'DAD_ShowDragImage',\
    DllCanUnloadNow,'DllCanUnloadNow',\
    DllGetActivationFactory,'DllGetActivationFactory',\
    DllGetVersion,'DllGetVersion',\
    DllRegisterServer,'DllRegisterServer',\
    DllUnregisterServer,'DllUnregisterServer',\
    DoEnvironmentSubstA,'DoEnvironmentSubstA',\
    DoEnvironmentSubstW,'DoEnvironmentSubstW',\
    DragAcceptFiles,'DragAcceptFiles',\
    DragFinish,'DragFinish',\
    DragQueryFileA,'DragQueryFileA',\
    DragQueryFileAorW,'DragQueryFileAorW',\
    DragQueryFileW,'DragQueryFileW',\
    DragQueryPoint,'DragQueryPoint',\
    DriveType,'DriveType',\
    DuplicateIcon,'DuplicateIcon',\
    ExtractAssociatedIconA,'ExtractAssociatedIconA',\
    ExtractAssociatedIconExA,'ExtractAssociatedIconExA',\
    ExtractAssociatedIconExW,'ExtractAssociatedIconExW',\
    ExtractAssociatedIconW,'ExtractAssociatedIconW',\
    ExtractIconA,'ExtractIconA',\
    ExtractIconExA,'ExtractIconExA',\
    ExtractIconExW,'ExtractIconExW',\
    ExtractIconResInfoA,'ExtractIconResInfoA',\
    ExtractIconResInfoW,'ExtractIconResInfoW',\
    ExtractIconW,'ExtractIconW',\
    ExtractVersionResource16W,'ExtractVersionResource16W',\
    FindExecutableA,'FindExecutableA',\
    FindExecutableW,'FindExecutableW',\
    FindExeDlgProc,'FindExeDlgProc',\
    FreeIconList,'FreeIconList',\
    GetCurrentProcessExplicitAppUserModelID,'GetCurrentProcessExplicitAppUserModelID',\
    GetFileNameFromBrowse,'GetFileNameFromBrowse',\
    ILAppendID,'ILAppendID',\
    ILClone,'ILClone',\
    ILCloneFirst,'ILCloneFirst',\
    ILCombine,'ILCombine',\
    ILCreateFromPathA,'ILCreateFromPathA',\
    ILCreateFromPathW,'ILCreateFromPathW',\
    ILFindChild,'ILFindChild',\
    ILFindLastID,'ILFindLastID',\
    ILFree,'ILFree',\
    ILGetNext,'ILGetNext',\
    ILGetSize,'ILGetSize',\
    ILIsEqual,'ILIsEqual',\
    ILIsParent,'ILIsParent',\
    ILLoadFromStream,'ILLoadFromStream',\
    ILLoadFromStreamEx,'ILLoadFromStreamEx',\
    ILRemoveLastID,'ILRemoveLastID',\
    ILSaveToStream,'ILSaveToStream',\
    InitNetworkAddressControl,'InitNetworkAddressControl',\
    InternalExtractIconListA,'InternalExtractIconListA',\
    InternalExtractIconListW,'InternalExtractIconListW',\
    IsLFNDrive,'IsLFNDrive',\
    IsLFNDriveA,'IsLFNDriveA',\
    IsLFNDriveW,'IsLFNDriveW',\
    IsNetDrive,'IsNetDrive',\
    IsProcessAnExplorer,'IsProcessAnExplorer',\
    IsUserAnAdmin,'IsUserAnAdmin',\
    OpenAs_RunDLLA,'OpenAs_RunDLLA',\
    OpenAs_RunDLLW,'OpenAs_RunDLLW',\
    OpenRegStream,'OpenRegStream',\
    Options_RunDLLA,'Options_RunDLLA',\
    Options_RunDLLW,'Options_RunDLLW',\
    PathCleanupSpec,'PathCleanupSpec',\
    PathGetShortPath,'PathGetShortPath',\
    PathIsExe,'PathIsExe',\
    PathIsSlowA,'PathIsSlowA',\
    PathIsSlowW,'PathIsSlowW',\
    PathMakeUniqueName,'PathMakeUniqueName',\
    PathProcessCommand,'PathProcessCommand',\
    PathResolve,'PathResolve',\
    PathYetAnotherMakeUniqueName,'PathYetAnotherMakeUniqueName',\
    PickIconDlg,'PickIconDlg',\
    PifMgr_CloseProperties,'PifMgr_CloseProperties',\
    PifMgr_GetProperties,'PifMgr_GetProperties',\
    PifMgr_OpenProperties,'PifMgr_OpenProperties',\
    PifMgr_SetProperties,'PifMgr_SetProperties',\
    ReadCabinetState,'ReadCabinetState',\
    RealDriveType,'RealDriveType',\
    RealShellExecuteA,'RealShellExecuteA',\
    RealShellExecuteExA,'RealShellExecuteExA',\
    RealShellExecuteExW,'RealShellExecuteExW',\
    RealShellExecuteW,'RealShellExecuteW',\
    RegenerateUserEnvironment,'RegenerateUserEnvironment',\
    RestartDialog,'RestartDialog',\
    RestartDialogEx,'RestartDialogEx',\
    RunAsNewUser_RunDLLW,'RunAsNewUser_RunDLLW',\
    SetCurrentProcessExplicitAppUserModelID,'SetCurrentProcessExplicitAppUserModelID',\
    SHAddDefaultPropertiesByExt,'SHAddDefaultPropertiesByExt',\
    SHAddFromPropSheetExtArray,'SHAddFromPropSheetExtArray',\
    SHAddToRecentDocs,'SHAddToRecentDocs',\
    SHAlloc,'SHAlloc',\
    SHAllocShared,'SHAllocShared',\
    SHAppBarMessage,'SHAppBarMessage',\
    SHAssocEnumHandlers,'SHAssocEnumHandlers',\
    SHAssocEnumHandlersForProtocolByApplication,'SHAssocEnumHandlersForProtocolByApplication',\
    SHBindToFolderIDListParent,'SHBindToFolderIDListParent',\
    SHBindToFolderIDListParentEx,'SHBindToFolderIDListParentEx',\
    SHBindToObject,'SHBindToObject',\
    SHBindToParent,'SHBindToParent',\
    SHBrowseForFolderA,'SHBrowseForFolderA',\
    SHBrowseForFolderW,'SHBrowseForFolderW',\
    SHChangeNotification_Lock,'SHChangeNotification_Lock',\
    SHChangeNotification_Unlock,'SHChangeNotification_Unlock',\
    SHChangeNotify,'SHChangeNotify',\
    SHChangeNotifyDeregister,'SHChangeNotifyDeregister',\
    SHChangeNotifyRegister,'SHChangeNotifyRegister',\
    SHChangeNotifyRegisterThread,'SHChangeNotifyRegisterThread',\
    SHChangeNotifySuspendResume,'SHChangeNotifySuspendResume',\
    SHCloneSpecialIDList,'SHCloneSpecialIDList',\
    SHCLSIDFromString,'SHCLSIDFromString',\
    SHCoCreateInstance,'SHCoCreateInstance',\
    SHCreateAssociationRegistration,'SHCreateAssociationRegistration',\
    SHCreateDataObject,'SHCreateDataObject',\
    SHCreateDefaultContextMenu,'SHCreateDefaultContextMenu',\
    SHCreateDefaultExtractIcon,'SHCreateDefaultExtractIcon',\
    SHCreateDefaultPropertiesOp,'SHCreateDefaultPropertiesOp',\
    SHCreateDirectory,'SHCreateDirectory',\
    SHCreateDirectoryExA,'SHCreateDirectoryExA',\
    SHCreateDirectoryExW,'SHCreateDirectoryExW',\
    SHCreateFileExtractIconW,'SHCreateFileExtractIconW',\
    SHCreateItemFromIDList,'SHCreateItemFromIDList',\
    SHCreateItemFromParsingName,'SHCreateItemFromParsingName',\
    SHCreateItemFromRelativeName,'SHCreateItemFromRelativeName',\
    SHCreateItemInKnownFolder,'SHCreateItemInKnownFolder',\
    SHCreateItemWithParent,'SHCreateItemWithParent',\
    SHCreateProcessAsUserW,'SHCreateProcessAsUserW',\
    SHCreatePropSheetExtArray,'SHCreatePropSheetExtArray',\
    SHCreateQueryCancelAutoPlayMoniker,'SHCreateQueryCancelAutoPlayMoniker',\
    SHCreateShellFolderView,'SHCreateShellFolderView',\
    SHCreateShellFolderViewEx,'SHCreateShellFolderViewEx',\
    SHCreateShellItem,'SHCreateShellItem',\
    SHCreateShellItemArray,'SHCreateShellItemArray',\
    SHCreateShellItemArrayFromDataObject,'SHCreateShellItemArrayFromDataObject',\
    SHCreateShellItemArrayFromIDLists,'SHCreateShellItemArrayFromIDLists',\
    SHCreateShellItemArrayFromShellItem,'SHCreateShellItemArrayFromShellItem',\
    SHCreateStdEnumFmtEtc,'SHCreateStdEnumFmtEtc',\
    SHDefExtractIconA,'SHDefExtractIconA',\
    SHDefExtractIconW,'SHDefExtractIconW',\
    SHDestroyPropSheetExtArray,'SHDestroyPropSheetExtArray',\
    SHDoDragDrop,'SHDoDragDrop',\
    SheChangeDirA,'SheChangeDirA',\
    SheChangeDirExA,'SheChangeDirExA',\
    SheChangeDirExW,'SheChangeDirExW',\
    SheChangeDirW,'SheChangeDirW',\
    SheFullPathA,'SheFullPathA',\
    SheFullPathW,'SheFullPathW',\
    SheGetCurDrive,'SheGetCurDrive',\
    SheGetDirA,'SheGetDirA',\
    SheGetDirExW,'SheGetDirExW',\
    SheGetDirW,'SheGetDirW',\
    SheGetPathOffsetW,'SheGetPathOffsetW',\
    Shell_GetCachedImageIndex,'Shell_GetCachedImageIndex',\
    Shell_GetCachedImageIndexA,'Shell_GetCachedImageIndexA',\
    Shell_GetCachedImageIndexW,'Shell_GetCachedImageIndexW',\
    Shell_GetImageLists,'Shell_GetImageLists',\
    Shell_MergeMenus,'Shell_MergeMenus',\
    Shell_NotifyIconA,'Shell_NotifyIconA',\
    Shell_NotifyIconGetRect,'Shell_NotifyIconGetRect',\
    Shell_NotifyIconW,'Shell_NotifyIconW',\
    ShellAboutA,'ShellAboutA',\
    ShellAboutW,'ShellAboutW',\
    ShellExec_RunDLLA,'ShellExec_RunDLLA',\
    ShellExec_RunDLLW,'ShellExec_RunDLLW',\
    ShellExecuteA,'ShellExecuteA',\
    ShellExecuteExA,'ShellExecuteExA',\
    ShellExecuteExW,'ShellExecuteExW',\
    ShellExecuteW,'ShellExecuteW',\
    ShellHookProc,'ShellHookProc',\
    ShellMessageBoxA,'ShellMessageBoxA',\
    ShellMessageBoxW,'ShellMessageBoxW',\
    SHEmptyRecycleBinA,'SHEmptyRecycleBinA',\
    SHEmptyRecycleBinW,'SHEmptyRecycleBinW',\
    SHEnableServiceObject,'SHEnableServiceObject',\
    SHEnumerateUnreadMailAccountsW,'SHEnumerateUnreadMailAccountsW',\
    SheRemoveQuotesA,'SheRemoveQuotesA',\
    SheRemoveQuotesW,'SheRemoveQuotesW',\
    SheSetCurDrive,'SheSetCurDrive',\
    SheShortenPathA,'SheShortenPathA',\
    SheShortenPathW,'SheShortenPathW',\
    SHEvaluateSystemCommandTemplate,'SHEvaluateSystemCommandTemplate',\
    SHExtractIconsW,'SHExtractIconsW',\
    SHFileOperationA,'SHFileOperationA',\
    SHFileOperationW,'SHFileOperationW',\
    SHFind_InitMenuPopup,'SHFind_InitMenuPopup',\
    SHFindFiles,'SHFindFiles',\
    SHFlushClipboard,'SHFlushClipboard',\
    SHFlushSFCache,'SHFlushSFCache',\
    SHFormatDrive,'SHFormatDrive',\
    SHFree,'SHFree',\
    SHFreeNameMappings,'SHFreeNameMappings',\
    SHFreeShared,'SHFreeShared',\
    SHGetAttributesFromDataObject,'SHGetAttributesFromDataObject',\
    SHGetDataFromIDListA,'SHGetDataFromIDListA',\
    SHGetDataFromIDListW,'SHGetDataFromIDListW',\
    SHGetDesktopFolder,'SHGetDesktopFolder',\
    SHGetDiskFreeSpaceA,'SHGetDiskFreeSpaceA',\
    SHGetDiskFreeSpaceExA,'SHGetDiskFreeSpaceExA',\
    SHGetDiskFreeSpaceExW,'SHGetDiskFreeSpaceExW',\
    SHGetDriveMedia,'SHGetDriveMedia',\
    SHGetFileInfoA,'SHGetFileInfoA',\
    SHGetFileInfoW,'SHGetFileInfoW',\
    SHGetFolderLocation,'SHGetFolderLocation',\
    SHGetFolderPathA,'SHGetFolderPathA',\
    SHGetFolderPathAndSubDirA,'SHGetFolderPathAndSubDirA',\
    SHGetFolderPathAndSubDirW,'SHGetFolderPathAndSubDirW',\
    SHGetFolderPathEx,'SHGetFolderPathEx',\
    SHGetFolderPathW,'SHGetFolderPathW',\
    SHGetIconOverlayIndexA,'SHGetIconOverlayIndexA',\
    SHGetIconOverlayIndexW,'SHGetIconOverlayIndexW',\
    SHGetIDListFromObject,'SHGetIDListFromObject',\
    SHGetImageList,'SHGetImageList',\
    SHGetInstanceExplorer,'SHGetInstanceExplorer',\
    SHGetItemFromDataObject,'SHGetItemFromDataObject',\
    SHGetItemFromObject,'SHGetItemFromObject',\
    SHGetKnownFolderIDList,'SHGetKnownFolderIDList',\
    SHGetKnownFolderItem,'SHGetKnownFolderItem',\
    SHGetKnownFolderPath,'SHGetKnownFolderPath',\
    SHGetLocalizedName,'SHGetLocalizedName',\
    SHGetMalloc,'SHGetMalloc',\
    SHGetNameFromIDList,'SHGetNameFromIDList',\
    SHGetNewLinkInfoA,'SHGetNewLinkInfoA',\
    SHGetNewLinkInfoW,'SHGetNewLinkInfoW',\
    SHGetPathFromIDListA,'SHGetPathFromIDListA',\
    SHGetPathFromIDListEx,'SHGetPathFromIDListEx',\
    SHGetPathFromIDListW,'SHGetPathFromIDListW',\
    SHGetPropertyStoreForWindow,'SHGetPropertyStoreForWindow',\
    SHGetPropertyStoreFromIDList,'SHGetPropertyStoreFromIDList',\
    SHGetPropertyStoreFromParsingName,'SHGetPropertyStoreFromParsingName',\
    SHGetRealIDL,'SHGetRealIDL',\
    SHGetSetFolderCustomSettings,'SHGetSetFolderCustomSettings',\
    SHGetSetFolderCustomSettingsW,'SHGetSetFolderCustomSettingsW',\
    SHGetSetSettings,'SHGetSetSettings',\
    SHGetSettings,'SHGetSettings',\
    SHGetShellStyleHInstance,'SHGetShellStyleHInstance',\
    SHGetSpecialFolderLocation,'SHGetSpecialFolderLocation',\
    SHGetSpecialFolderPathA,'SHGetSpecialFolderPathA',\
    SHGetSpecialFolderPathW,'SHGetSpecialFolderPathW',\
    SHGetStockIconInfo,'SHGetStockIconInfo',\
    SHGetTemporaryPropertyForItem,'SHGetTemporaryPropertyForItem',\
    SHGetUnreadMailCountW,'SHGetUnreadMailCountW',\
    SHHandleUpdateImage,'SHHandleUpdateImage',\
    SHHelpShortcuts_RunDLLA,'SHHelpShortcuts_RunDLLA',\
    SHHelpShortcuts_RunDLLW,'SHHelpShortcuts_RunDLLW',\
    SHILCreateFromPath,'SHILCreateFromPath',\
    SHInvokePrinterCommandA,'SHInvokePrinterCommandA',\
    SHInvokePrinterCommandW,'SHInvokePrinterCommandW',\
    SHIsFileAvailableOffline,'SHIsFileAvailableOffline',\
    SHLimitInputEdit,'SHLimitInputEdit',\
    SHLoadInProc,'SHLoadInProc',\
    SHLoadNonloadedIconOverlayIdentifiers,'SHLoadNonloadedIconOverlayIdentifiers',\
    SHLockShared,'SHLockShared',\
    SHMapIDListToImageListIndexAsync,'SHMapIDListToImageListIndexAsync',\
    SHMapPIDLToSystemImageListIndex,'SHMapPIDLToSystemImageListIndex',\
    SHMultiFileProperties,'SHMultiFileProperties',\
    SHObjectProperties,'SHObjectProperties',\
    SHOpenFolderAndSelectItems,'SHOpenFolderAndSelectItems',\
    SHOpenPropSheetW,'SHOpenPropSheetW',\
    SHOpenWithDialog,'SHOpenWithDialog',\
    SHParseDisplayName,'SHParseDisplayName',\
    SHPathPrepareForWriteA,'SHPathPrepareForWriteA',\
    SHPathPrepareForWriteW,'SHPathPrepareForWriteW',\
    SHPropStgCreate,'SHPropStgCreate',\
    SHPropStgReadMultiple,'SHPropStgReadMultiple',\
    SHPropStgWriteMultiple,'SHPropStgWriteMultiple',\
    SHQueryRecycleBinA,'SHQueryRecycleBinA',\
    SHQueryRecycleBinW,'SHQueryRecycleBinW',\
    SHQueryUserNotificationState,'SHQueryUserNotificationState',\
    SHRemoveLocalizedName,'SHRemoveLocalizedName',\
    SHReplaceFromPropSheetExtArray,'SHReplaceFromPropSheetExtArray',\
    SHResolveLibrary,'SHResolveLibrary',\
    SHRestricted,'SHRestricted',\
    SHRunControlPanel,'SHRunControlPanel',\
    SHSetDefaultProperties,'SHSetDefaultProperties',\
    SHSetFolderPathA,'SHSetFolderPathA',\
    SHSetFolderPathW,'SHSetFolderPathW',\
    SHSetInstanceExplorer,'SHSetInstanceExplorer',\
    SHSetKnownFolderPath,'SHSetKnownFolderPath',\
    SHSetLocalizedName,'SHSetLocalizedName',\
    SHSetTemporaryPropertyForItem,'SHSetTemporaryPropertyForItem',\
    SHSetUnreadMailCountW,'SHSetUnreadMailCountW',\
    SHShellFolderView_Message,'SHShellFolderView_Message',\
    SHShowManageLibraryUI,'SHShowManageLibraryUI',\
    SHSimpleIDListFromPath,'SHSimpleIDListFromPath',\
    SHStartNetConnectionDialogW,'SHStartNetConnectionDialogW',\
    SHTestTokenMembership,'SHTestTokenMembership',\
    SHUnlockShared,'SHLockShared',\
    SHUpdateImageA,'SHUpdateImageA',\
    SHUpdateImageW,'SHUpdateImageW',\
    SHUpdateRecycleBinIcon,'SHUpdateRecycleBinIcon',\
    SHValidateUNC,'SHValidateUNC',\
    SignalFileOpen,'SignalFileOpen',\
    StgMakeUniqueName,'StgMakeUniqueName',\
    StrChrA,'StrChrA',\
    StrChrIA,'StrChrIA',\
    StrChrIW,'StrChrIW',\
    StrChrW,'StrChrW',\
    StrCmpNA,'StrCmpNA',\
    StrCmpNIA,'StrCmpNIA',\
    StrCmpNIW,'StrCmpNIW',\
    StrCmpNW,'StrCmpNW',\
    StrNCmpA,'StrNCmpA',\
    StrNCmpIA,'StrNCmpIA',\
    StrNCmpIW,'StrNCmpIW',\
    StrNCmpW,'StrNCmpW',\
    StrRChrA,'StrRChrA',\
    StrRChrIA,'StrRChrIA',\
    StrRChrIW,'StrRChrIW',\
    StrRChrW,'StrRChrW',\
    StrRStrA,'StrRStrA',\
    StrRStrIA,'StrRStrIA',\
    StrRStrIW,'StrRStrIW',\
    StrRStrW,'StrRStrW',\
    StrStrA,'StrStrA',\
    StrStrIA,'StrStrIA',\
    StrStrIW,'StrStrIW',\
    StrStrW,'StrStrW',\
    WaitForExplorerRestartW,'WaitForExplorerRestartW',\
    Win32DeleteFile,'Win32DeleteFile',\
    WOWShellExecute,'WOWShellExecute',\
    WriteCabinetState,'WriteCabinetState'
else
    import shell32,\
    AppCompat_RunDLLW,'AppCompat_RunDLLW',\
    AssocCreateForClasses,'AssocCreateForClasses',\
    AssocGetDetailsOfPropKey,'AssocGetDetailsOfPropKey',\
    CallCPLEntry16,'CallCPLEntry16',\
    CDefFolderMenu_Create,'CDefFolderMenu_Create',\
    CDefFolderMenu_Create2,'CDefFolderMenu_Create2',\
    CheckEscapesA,'CheckEscapesA',\
    CheckEscapesW,'CheckEscapesW',\
    CIDLData_CreateFromIDArray,'CIDLData_CreateFromIDArray',\
    CommandLineToArgvW,'CommandLineToArgvW',\
    Control_FillCache_RunDLLA,'Control_FillCache_RunDLLA',\
    Control_FillCache_RunDLLW,'Control_FillCache_RunDLLW',\
    Control_RunDLLAsUserW,'Control_RunDLLAsUserW',\
    DAD_AutoScroll,'DAD_AutoScroll',\
    DAD_DragEnterEx,'DAD_DragEnterEx',\
    DAD_DragEnterEx2,'DAD_DragEnterEx2',\
    DAD_DragLeave,'DAD_DragLeave',\
    DAD_DragMove,'DAD_DragMove',\
    DAD_SetDragImage,'DAD_SetDragImage',\
    DAD_ShowDragImage,'DAD_ShowDragImage',\
    DllCanUnloadNow,'DllCanUnloadNow',\
    DllGetActivationFactory,'DllGetActivationFactory',\
    DllGetVersion,'DllGetVersion',\
    DllRegisterServer,'DllRegisterServer',\
    DllUnregisterServer,'DllUnregisterServer',\
    DoEnvironmentSubstA,'DoEnvironmentSubstA',\
    DoEnvironmentSubstW,'DoEnvironmentSubstW',\
    DragAcceptFiles,'DragAcceptFiles',\
    DragFinish,'DragFinish',\
    DragQueryFileA,'DragQueryFileA',\
    DragQueryFileAorW,'DragQueryFileAorW',\
    DragQueryFileW,'DragQueryFileW',\
    DragQueryPoint,'DragQueryPoint',\
    DriveType,'DriveType',\
    DuplicateIcon,'DuplicateIcon',\
    ExtractAssociatedIconA,'ExtractAssociatedIconA',\
    ExtractAssociatedIconExA,'ExtractAssociatedIconExA',\
    ExtractAssociatedIconExW,'ExtractAssociatedIconExW',\
    ExtractAssociatedIconW,'ExtractAssociatedIconW',\
    ExtractIconA,'ExtractIconA',\
    ExtractIconExA,'ExtractIconExA',\
    ExtractIconExW,'ExtractIconExW',\
    ExtractIconResInfoA,'ExtractIconResInfoA',\
    ExtractIconResInfoW,'ExtractIconResInfoW',\
    ExtractIconW,'ExtractIconW',\
    ExtractVersionResource16W,'ExtractVersionResource16W',\
    FindExecutableA,'FindExecutableA',\
    FindExecutableW,'FindExecutableW',\
    FindExeDlgProc,'FindExeDlgProc',\
    FreeIconList,'FreeIconList',\
    GetCurrentProcessExplicitAppUserModelID,'GetCurrentProcessExplicitAppUserModelID',\
    GetFileNameFromBrowse,'GetFileNameFromBrowse',\
    ILAppendID,'ILAppendID',\
    ILClone,'ILClone',\
    ILCloneFirst,'ILCloneFirst',\
    ILCombine,'ILCombine',\
    ILCreateFromPathA,'ILCreateFromPathA',\
    ILCreateFromPathW,'ILCreateFromPathW',\
    ILFindChild,'ILFindChild',\
    ILFindLastID,'ILFindLastID',\
    ILFree,'ILFree',\
    ILGetNext,'ILGetNext',\
    ILGetSize,'ILGetSize',\
    ILIsEqual,'ILIsEqual',\
    ILIsParent,'ILIsParent',\
    ILLoadFromStream,'ILLoadFromStream',\
    ILLoadFromStreamEx,'ILLoadFromStreamEx',\
    ILRemoveLastID,'ILRemoveLastID',\
    ILSaveToStream,'ILSaveToStream',\
    InitNetworkAddressControl,'InitNetworkAddressControl',\
    InternalExtractIconListA,'InternalExtractIconListA',\
    InternalExtractIconListW,'InternalExtractIconListW',\
    IsLFNDrive,'IsLFNDrive',\
    IsLFNDriveA,'IsLFNDriveA',\
    IsLFNDriveW,'IsLFNDriveW',\
    IsNetDrive,'IsNetDrive',\
    IsProcessAnExplorer,'IsProcessAnExplorer',\
    IsUserAnAdmin,'IsUserAnAdmin',\
    OpenRegStream,'OpenRegStream',\
    Options_RunDLLA,'Options_RunDLLA',\
    Options_RunDLLW,'Options_RunDLLW',\
    PathCleanupSpec,'PathCleanupSpec',\
    PathGetShortPath,'PathGetShortPath',\
    PathIsExe,'PathIsExe',\
    PathIsSlowA,'PathIsSlowA',\
    PathIsSlowW,'PathIsSlowW',\
    PathMakeUniqueName,'PathMakeUniqueName',\
    PathProcessCommand,'PathProcessCommand',\
    PathResolve,'PathResolve',\
    PathYetAnotherMakeUniqueName,'PathYetAnotherMakeUniqueName',\
    PickIconDlg,'PickIconDlg',\
    PifMgr_CloseProperties,'PifMgr_CloseProperties',\
    PifMgr_GetProperties,'PifMgr_GetProperties',\
    PifMgr_OpenProperties,'PifMgr_OpenProperties',\
    PifMgr_SetProperties,'PifMgr_SetProperties',\
    ReadCabinetState,'ReadCabinetState',\
    RealDriveType,'RealDriveType',\
    RealShellExecuteA,'RealShellExecuteA',\
    RealShellExecuteExA,'RealShellExecuteExA',\
    RealShellExecuteExW,'RealShellExecuteExW',\
    RealShellExecuteW,'RealShellExecuteW',\
    RegenerateUserEnvironment,'RegenerateUserEnvironment',\
    RestartDialog,'RestartDialog',\
    RestartDialogEx,'RestartDialogEx',\
    RunAsNewUser_RunDLLW,'RunAsNewUser_RunDLLW',\
    SetCurrentProcessExplicitAppUserModelID,'SetCurrentProcessExplicitAppUserModelID',\
    SHAddDefaultPropertiesByExt,'SHAddDefaultPropertiesByExt',\
    SHAddFromPropSheetExtArray,'SHAddFromPropSheetExtArray',\
    SHAddToRecentDocs,'SHAddToRecentDocs',\
    SHAlloc,'SHAlloc',\
    SHAllocShared,'SHAllocShared',\
    SHAppBarMessage,'SHAppBarMessage',\
    SHAssocEnumHandlers,'SHAssocEnumHandlers',\
    SHAssocEnumHandlersForProtocolByApplication,'SHAssocEnumHandlersForProtocolByApplication',\
    SHBindToFolderIDListParent,'SHBindToFolderIDListParent',\
    SHBindToFolderIDListParentEx,'SHBindToFolderIDListParentEx',\
    SHBindToObject,'SHBindToObject',\
    SHBindToParent,'SHBindToParent',\
    SHBrowseForFolderA,'SHBrowseForFolderA',\
    SHBrowseForFolderW,'SHBrowseForFolderW',\
    SHChangeNotification_Lock,'SHChangeNotification_Lock',\
    SHChangeNotification_Unlock,'SHChangeNotification_Unlock',\
    SHChangeNotify,'SHChangeNotify',\
    SHChangeNotifyDeregister,'SHChangeNotifyDeregister',\
    SHChangeNotifyRegister,'SHChangeNotifyRegister',\
    SHChangeNotifyRegisterThread,'SHChangeNotifyRegisterThread',\
    SHChangeNotifySuspendResume,'SHChangeNotifySuspendResume',\
    SHCloneSpecialIDList,'SHCloneSpecialIDList',\
    SHCLSIDFromString,'SHCLSIDFromString',\
    SHCoCreateInstance,'SHCoCreateInstance',\
    SHCreateAssociationRegistration,'SHCreateAssociationRegistration',\
    SHCreateDataObject,'SHCreateDataObject',\
    SHCreateDefaultContextMenu,'SHCreateDefaultContextMenu',\
    SHCreateDefaultExtractIcon,'SHCreateDefaultExtractIcon',\
    SHCreateDefaultPropertiesOp,'SHCreateDefaultPropertiesOp',\
    SHCreateDirectory,'SHCreateDirectory',\
    SHCreateDirectoryExA,'SHCreateDirectoryExA',\
    SHCreateDirectoryExW,'SHCreateDirectoryExW',\
    SHCreateFileExtractIconW,'SHCreateFileExtractIconW',\
    SHCreateItemFromIDList,'SHCreateItemFromIDList',\
    SHCreateItemFromParsingName,'SHCreateItemFromParsingName',\
    SHCreateItemFromRelativeName,'SHCreateItemFromRelativeName',\
    SHCreateItemInKnownFolder,'SHCreateItemInKnownFolder',\
    SHCreateItemWithParent,'SHCreateItemWithParent',\
    SHCreateProcessAsUserW,'SHCreateProcessAsUserW',\
    SHCreatePropSheetExtArray,'SHCreatePropSheetExtArray',\
    SHCreateQueryCancelAutoPlayMoniker,'SHCreateQueryCancelAutoPlayMoniker',\
    SHCreateShellFolderView,'SHCreateShellFolderView',\
    SHCreateShellFolderViewEx,'SHCreateShellFolderViewEx',\
    SHCreateShellItem,'SHCreateShellItem',\
    SHCreateShellItemArray,'SHCreateShellItemArray',\
    SHCreateShellItemArrayFromDataObject,'SHCreateShellItemArrayFromDataObject',\
    SHCreateShellItemArrayFromIDLists,'SHCreateShellItemArrayFromIDLists',\
    SHCreateShellItemArrayFromShellItem,'SHCreateShellItemArrayFromShellItem',\
    SHCreateStdEnumFmtEtc,'SHCreateStdEnumFmtEtc',\
    SHDefExtractIconA,'SHDefExtractIconA',\
    SHDefExtractIconW,'SHDefExtractIconW',\
    SHDestroyPropSheetExtArray,'SHDestroyPropSheetExtArray',\
    SHDoDragDrop,'SHDoDragDrop',\
    SheChangeDirA,'SheChangeDirA',\
    SheChangeDirExA,'SheChangeDirExA',\
    SheChangeDirExW,'SheChangeDirExW',\
    SheChangeDirW,'SheChangeDirW',\
    SheFullPathA,'SheFullPathA',\
    SheFullPathW,'SheFullPathW',\
    SheGetCurDrive,'SheGetCurDrive',\
    SheGetDirA,'SheGetDirA',\
    SheGetDirExW,'SheGetDirExW',\
    SheGetDirW,'SheGetDirW',\
    SheGetPathOffsetW,'SheGetPathOffsetW',\
    Shell_GetCachedImageIndex,'Shell_GetCachedImageIndex',\
    Shell_GetCachedImageIndexA,'Shell_GetCachedImageIndexA',\
    Shell_GetCachedImageIndexW,'Shell_GetCachedImageIndexW',\
    Shell_GetImageLists,'Shell_GetImageLists',\
    Shell_MergeMenus,'Shell_MergeMenus',\
    Shell_NotifyIconA,'Shell_NotifyIconA',\
    Shell_NotifyIconGetRect,'Shell_NotifyIconGetRect',\
    Shell_NotifyIconW,'Shell_NotifyIconW',\
    ShellAboutA,'ShellAboutA',\
    ShellAboutW,'ShellAboutW',\
    ShellExec_RunDLLA,'ShellExec_RunDLLA',\
    ShellExec_RunDLLW,'ShellExec_RunDLLW',\
    ShellExecuteA,'ShellExecuteA',\
    ShellExecuteExA,'ShellExecuteExA',\
    ShellExecuteExW,'ShellExecuteExW',\
    ShellExecuteW,'ShellExecuteW',\
    ShellHookProc,'ShellHookProc',\
    ShellMessageBoxA,'ShellMessageBoxA',\
    ShellMessageBoxW,'ShellMessageBoxW',\
    SHEmptyRecycleBinA,'SHEmptyRecycleBinA',\
    SHEmptyRecycleBinW,'SHEmptyRecycleBinW',\
    SHEnableServiceObject,'SHEnableServiceObject',\
    SHEnumerateUnreadMailAccountsW,'SHEnumerateUnreadMailAccountsW',\
    SheRemoveQuotesA,'SheRemoveQuotesA',\
    SheRemoveQuotesW,'SheRemoveQuotesW',\
    SheSetCurDrive,'SheSetCurDrive',\
    SheShortenPathA,'SheShortenPathA',\
    SheShortenPathW,'SheShortenPathW',\
    SHEvaluateSystemCommandTemplate,'SHEvaluateSystemCommandTemplate',\
    SHExtractIconsW,'SHExtractIconsW',\
    SHFileOperationA,'SHFileOperationA',\
    SHFileOperationW,'SHFileOperationW',\
    SHFind_InitMenuPopup,'SHFind_InitMenuPopup',\
    SHFindFiles,'SHFindFiles',\
    SHFlushClipboard,'SHFlushClipboard',\
    SHFlushSFCache,'SHFlushSFCache',\
    SHFormatDrive,'SHFormatDrive',\
    SHFree,'SHFree',\
    SHFreeNameMappings,'SHFreeNameMappings',\
    SHFreeShared,'SHFreeShared',\
    SHGetAttributesFromDataObject,'SHGetAttributesFromDataObject',\
    SHGetDataFromIDListA,'SHGetDataFromIDListA',\
    SHGetDataFromIDListW,'SHGetDataFromIDListW',\
    SHGetDesktopFolder,'SHGetDesktopFolder',\
    SHGetDiskFreeSpaceA,'SHGetDiskFreeSpaceA',\
    SHGetDiskFreeSpaceExA,'SHGetDiskFreeSpaceExA',\
    SHGetDiskFreeSpaceExW,'SHGetDiskFreeSpaceExW',\
    SHGetDriveMedia,'SHGetDriveMedia',\
    SHGetFileInfoA,'SHGetFileInfoA',\
    SHGetFileInfoW,'SHGetFileInfoW',\
    SHGetFolderLocation,'SHGetFolderLocation',\
    SHGetFolderPathA,'SHGetFolderPathA',\
    SHGetFolderPathAndSubDirA,'SHGetFolderPathAndSubDirA',\
    SHGetFolderPathAndSubDirW,'SHGetFolderPathAndSubDirW',\
    SHGetFolderPathEx,'SHGetFolderPathEx',\
    SHGetFolderPathW,'SHGetFolderPathW',\
    SHGetIconOverlayIndexA,'SHGetIconOverlayIndexA',\
    SHGetIconOverlayIndexW,'SHGetIconOverlayIndexW',\
    SHGetIDListFromObject,'SHGetIDListFromObject',\
    SHGetImageList,'SHGetImageList',\
    SHGetInstanceExplorer,'SHGetInstanceExplorer',\
    SHGetItemFromDataObject,'SHGetItemFromDataObject',\
    SHGetItemFromObject,'SHGetItemFromObject',\
    SHGetKnownFolderIDList,'SHGetKnownFolderIDList',\
    SHGetKnownFolderItem,'SHGetKnownFolderItem',\
    SHGetKnownFolderPath,'SHGetKnownFolderPath',\
    SHGetLocalizedName,'SHGetLocalizedName',\
    SHGetMalloc,'SHGetMalloc',\
    SHGetNameFromIDList,'SHGetNameFromIDList',\
    SHGetNewLinkInfoA,'SHGetNewLinkInfoA',\
    SHGetNewLinkInfoW,'SHGetNewLinkInfoW',\
    SHGetPathFromIDListA,'SHGetPathFromIDListA',\
    SHGetPathFromIDListEx,'SHGetPathFromIDListEx',\
    SHGetPathFromIDListW,'SHGetPathFromIDListW',\
    SHGetPropertyStoreForWindow,'SHGetPropertyStoreForWindow',\
    SHGetPropertyStoreFromIDList,'SHGetPropertyStoreFromIDList',\
    SHGetPropertyStoreFromParsingName,'SHGetPropertyStoreFromParsingName',\
    SHGetRealIDL,'SHGetRealIDL',\
    SHGetSetFolderCustomSettings,'SHGetSetFolderCustomSettings',\
    SHGetSetFolderCustomSettingsW,'SHGetSetFolderCustomSettingsW',\
    SHGetSetSettings,'SHGetSetSettings',\
    SHGetSettings,'SHGetSettings',\
    SHGetShellStyleHInstance,'SHGetShellStyleHInstance',\
    SHGetSpecialFolderLocation,'SHGetSpecialFolderLocation',\
    SHGetSpecialFolderPathA,'SHGetSpecialFolderPathA',\
    SHGetSpecialFolderPathW,'SHGetSpecialFolderPathW',\
    SHGetStockIconInfo,'SHGetStockIconInfo',\
    SHGetTemporaryPropertyForItem,'SHGetTemporaryPropertyForItem',\
    SHGetUnreadMailCountW,'SHGetUnreadMailCountW',\
    SHHandleUpdateImage,'SHHandleUpdateImage',\
    SHHelpShortcuts_RunDLLA,'SHHelpShortcuts_RunDLLA',\
    SHHelpShortcuts_RunDLLW,'SHHelpShortcuts_RunDLLW',\
    SHILCreateFromPath,'SHILCreateFromPath',\
    SHInvokePrinterCommandA,'SHInvokePrinterCommandA',\
    SHInvokePrinterCommandW,'SHInvokePrinterCommandW',\
    SHIsFileAvailableOffline,'SHIsFileAvailableOffline',\
    SHLimitInputEdit,'SHLimitInputEdit',\
    SHLoadInProc,'SHLoadInProc',\
    SHLoadNonloadedIconOverlayIdentifiers,'SHLoadNonloadedIconOverlayIdentifiers',\
    SHLockShared,'SHLockShared',\
    SHMapIDListToImageListIndexAsync,'SHMapIDListToImageListIndexAsync',\
    SHMapPIDLToSystemImageListIndex,'SHMapPIDLToSystemImageListIndex',\
    SHMultiFileProperties,'SHMultiFileProperties',\
    SHObjectProperties,'SHObjectProperties',\
    SHOpenFolderAndSelectItems,'SHOpenFolderAndSelectItems',\
    SHOpenPropSheetW,'SHOpenPropSheetW',\
    SHOpenWithDialog,'SHOpenWithDialog',\
    SHParseDisplayName,'SHParseDisplayName',\
    SHPathPrepareForWriteA,'SHPathPrepareForWriteA',\
    SHPathPrepareForWriteW,'SHPathPrepareForWriteW',\
    SHPropStgCreate,'SHPropStgCreate',\
    SHPropStgReadMultiple,'SHPropStgReadMultiple',\
    SHPropStgWriteMultiple,'SHPropStgWriteMultiple',\
    SHQueryRecycleBinA,'SHQueryRecycleBinA',\
    SHQueryRecycleBinW,'SHQueryRecycleBinW',\
    SHQueryUserNotificationState,'SHQueryUserNotificationState',\
    SHRemoveLocalizedName,'SHRemoveLocalizedName',\
    SHReplaceFromPropSheetExtArray,'SHReplaceFromPropSheetExtArray',\
    SHResolveLibrary,'SHResolveLibrary',\
    SHRestricted,'SHRestricted',\
    SHRunControlPanel,'SHRunControlPanel',\
    SHSetDefaultProperties,'SHSetDefaultProperties',\
    SHSetFolderPathA,'SHSetFolderPathA',\
    SHSetFolderPathW,'SHSetFolderPathW',\
    SHSetInstanceExplorer,'SHSetInstanceExplorer',\
    SHSetKnownFolderPath,'SHSetKnownFolderPath',\
    SHSetLocalizedName,'SHSetLocalizedName',\
    SHSetTemporaryPropertyForItem,'SHSetTemporaryPropertyForItem',\
    SHSetUnreadMailCountW,'SHSetUnreadMailCountW',\
    SHShellFolderView_Message,'SHShellFolderView_Message',\
    SHShowManageLibraryUI,'SHShowManageLibraryUI',\
    SHSimpleIDListFromPath,'SHSimpleIDListFromPath',\
    SHStartNetConnectionDialogW,'SHStartNetConnectionDialogW',\
    SHTestTokenMembership,'SHTestTokenMembership',\
    SHUnlockShared,'SHUnlockShared',\
    SHUpdateImageA,'SHUpdateImageA',\
    SHUpdateImageW,'SHUpdateImageW',\
    SHUpdateRecycleBinIcon,'SHUpdateRecycleBinIcon',\
    SHValidateUNC,'SHValidateUNC',\
    SignalFileOpen,'SignalFileOpen',\
    StgMakeUniqueName,'StgMakeUniqueName',\
    StrChrA,'StrChrA',\
    StrChrIA,'StrChrIA',\
    StrChrIW,'StrChrIW',\
    StrChrW,'StrChrW',\
    StrCmpNA,'StrCmpNA',\
    StrCmpNIA,'StrCmpNIA',\
    StrCmpNIW,'StrCmpNIW',\
    StrCmpNW,'StrCmpNW',\
    StrNCmpA,'StrNCmpA',\
    StrNCmpIA,'StrNCmpIA',\
    StrNCmpIW,'StrNCmpIW',\
    StrNCmpW,'StrNCmpW',\
    StrRChrA,'StrRChrA',\
    StrRChrIA,'StrRChrIA',\
    StrRChrIW,'StrRChrIW',\
    StrRChrW,'StrRChrW',\
    StrRStrA,'StrRStrA',\
    StrRStrIA,'StrRStrIA',\
    StrRStrIW,'StrRStrIW',\
    StrRStrW,'StrRStrW',\
    StrStrA,'StrStrA',\
    StrStrIA,'StrStrIA',\
    StrStrIW,'StrStrIW',\
    StrStrW,'StrStrW',\
    WaitForExplorerRestartW,'WaitForExplorerRestartW',\
    Win32DeleteFile,'Win32DeleteFile',\
    WOWShellExecute,'WOWShellExecute',\
    WriteCabinetState,'WriteCabinetState'
end if

api CheckEscapes,\
    if (NTDDI_VERSION <= NTDDI_VISTA)
	   Control_FillCache_RunDLL,\
    end if
	DoEnvironmentSubst,\
	DragQueryFile,\
	ExtractAssociatedIcon,\
	ExtractAssociatedIconEx,\
	ExtractIcon,\
	ExtractIconEx,\
	ExtractIconResInfo,\
	FindExecutable,\
	ILCreateFromPath,\
	InternalExtractIconList,\
	Options_RunDLL,\
	PathIsSlow,\
	RealShellExecute,\
	RealShellExecuteEx,\
	SHBrowseForFolder,\
	SHCreateDirectoryEx,\
	SheChangeDir,\
	SheChangeDirEx,\
	SheFullPath,\
	SheGetDir,\
	Shell_GetCachedImageIndex,\
	Shell_NotifyIcon,\
	ShellAbout,\
	ShellExec_RunDLL,\
	ShellExecute,\
	ShellExecuteEx,\
	ShellMessageBox,\
	SHEmptyRecycleBin,\
	SheRemoveQuotes,\
	SheShortenPath,\
	SHFileOperation,\
	SHGetDataFromIDList,\
	SHGetDiskFreeSpaceEx,\
	SHGetFileInfo,\
	SHGetFolderPath,\
	SHGetFolderPathAndSubDir,\
	SHGetIconOverlayIndex,\
	SHGetNewLinkInfo,\
	SHGetPathFromIDList,\
	SHGetSpecialFolderPath,\
	SHHelpShortcuts_RunDLL,\
	SHInvokePrinterCommand,\
	SHPathPrepareForWrite,\
	SHQueryRecycleBin,\
	SHSetFolderPath,\
	SHUpdateImage,\
	StrChr,\
	StrChrI,\
	StrCmpN,\
	StrCmpNI,\
	StrNCmp,\
	StrNCmpI,\
	StrRChr,\
	StrRChrI,\
	StrRStr,\
	StrRStrI,\
	StrStr,\
	StrStrI

end if ;SHELL32_INC
